catalog:
  title: 'YOLO ROS: Real-Time Object Detection for ROS'

templates:
- github
- freestyle
- base

variables:
  description: >-
    This is a ROS package developed for object detection in camera
    images.

    You only look once (YOLO) is a state-of-the-art, real-time object
    detection system
  recipe.maintainer:
  - flier@techfak.uni-bielefeld.de

  github.user: warp1337
  github.project: darknet_ros

  git.wipe-out-workspace?: true
  branches:
  - master

  extra-provides:
  - nature: freestyle
    target: darknet_ros_ethz
    version: master
  extra-requires:
  - nature: freestyle
    target: cuda
  - nature: cmake
    target: opencv-plus-contrib-cuda
    version: 3.3.1
  platform-requires:
    ubuntu:
      packages:
      - libboost-dev
      - libcuda1-384

  pre-build-hook/unix.command: |
    if [ -f ${toolkit.dir}/setup.sh ] ; then
      . ${toolkit.dir}/setup.sh
    else
      . /opt/ros/${ros}/setup.sh
    fi
    cd darknet_ros_msgs
    mkdir -p build
    cd build
    cmake .. -DCMAKE_INSTALL_PREFIX=${toolkit.dir} -DCMAKE_BUILD_TYPE=Release
    make && make install

  shell.command: |
    git clone https://github.com/pjreddie/darknet.git
    cd darknet
    git checkout 59ed1719d4aa77a462eb41dd4db2dd3a2f8e4a1b
    cd ..
    if [ -f ${toolkit.dir}/setup.sh ] ; then
      . ${toolkit.dir}/setup.sh
    else
      . /opt/ros/${ros}/setup.sh
    fi
    cd darknet_ros
    mkdir -p build
    cd build
    cmake .. -DCMAKE_INSTALL_PREFIX=${toolkit.dir} -DCMAKE_BUILD_TYPE=Release
    make -j2 && make install
    if [ $? -eq 0 ]; then
      echo '-----> OK, going on!'
    else
      echo '-----> Failure, noooo :|'
      exit 1
    fi
    cd ..
    echo "------------ Download tiny weights ... ---------------"
    wget 'https://techfak.de/clf-ml-data/yolo-weights/tiny-yolo-voc.weights'
    mkdir -p ${toolkit.dir}/share/darknet_ros/yolo_network_config/weights/
    cp -rf tiny-yolo-voc.weights ${toolkit.dir}/share/darknet_ros/yolo_network_config/weights/
    echo "------------ Create new custom cfg files ... ---------------"
    cd yolo_network_config
    cd cfg
    cp tiny-yolo-voc.cfg tiny-yolo-voc_batch.cfg
    sed -i 's#subdivisions=8#subdivisions=64#' tiny-yolo-voc_batch.cfg
    cd ../..
    cp -rf launch ${toolkit.dir}/share/darknet_ros/
    cp -rf config ${toolkit.dir}/share/darknet_ros/
    cp -rf yolo_network_config ${toolkit.dir}/share/darknet_ros/
    cp -f package.xml ${toolkit.dir}/share/darknet_ros/

versions:
- name: pepper_robocup
  variables:
    branch: pepper_robocup

    ros: kinetic
